var PB_Commands = {};

PB_Commands.browseTidbits = function() {
    PiggyBank.checkBeforeExecuting(PiggyBank.browseTidbits);
};

PB_Commands.browseMyPiggyBank = function() {
    PiggyBank.checkBeforeExecuting(PiggyBank.browseMyPiggyBank);
};

PB_Commands.track = function() {
    PiggyBank.checkBeforeExecuting(PiggyBank.track);
};

PB_Commands.tag = function() {
    PiggyBank.checkBeforeExecuting(PB_TagBar.open);
};

PB_Commands.reload = function() {
    PiggyBank.checkBeforeExecuting(PiggyBank.reload);
};

PB_Commands.viewInPiggyBank = function() {
    PiggyBank.checkBeforeExecuting(function() {
	    var webpageUrl = document.getElementById("content").contentDocument.location.href;
	    var url = PB_Extension.getPiggyBankURL() + "?command=focus&objectURI=" + encodeURI(webpageUrl);
	    PB_BrowserUtilities.openNewWindow(url);
	});
};

PB_Commands.viewInBanks = function() {
    PiggyBank.checkBeforeExecuting(function() {
	    var webpageUrl = document.getElementById("content").contentDocument.location.href;
	    var localStore = 
	        Components.classes["@mozilla.org/rdf/datasource;1?name=local-store"]
	            .getService(Components.interfaces.nsIRDFDataSource);
	    var rdfService = 
	        Components.classes["@mozilla.org/rdf/rdf-service;1"]
	            .getService(Components.interfaces.nsIRDFService);
	            
	    var typeProperty = rdfService.GetResource("http://www.w3.org/1999/02/22-rdf-syntax-ns#type");
	    var accountTypeResource = rdfService.GetResource(Simile.pb_Account);
	    var bankAddressProperty = rdfService.GetResource(Simile.pb_bankAddress);
	    var accountIDProperty = rdfService.GetResource(Simile.pb_accountID);
	    
	    var accounts = localStore.GetSources(typeProperty, accountTypeResource, true);
	    while (accounts.hasMoreElements()) {
	        var account = accounts.getNext();
	        var accountURI = account.Value;
	        
	        var bankAddress = localStore.GetTarget(account, bankAddressProperty, true).
	            QueryInterface(Components.interfaces.nsIRDFLiteral).Value;
	
	        var url = bankAddress + "?command=focus&objectURI=" + encodeURI(webpageUrl);
	        PB_BrowserUtilities.openNewWindow(url);
	    }
	});
};

PB_Commands.combine = function() {
    PiggyBank.checkBeforeExecuting(function() {
	    window.open("chrome://piggy-bank/content/combine-dialog.xul", "", "chrome,modal,dialog,resizable,width=500,height=400");
	});
}

PB_Commands.showBankAccounts = function() {
    PiggyBank.checkBeforeExecuting(function() {
	    window.open("chrome://piggy-bank/content/bank-accounts-dialog.xul", "", "chrome,modal,resizable,width=500,height=400");
	});
};

PB_Commands.showOptions = function() {
    // NOTE: we don't check before executing this because 
    //       we need it for debugging eventual problems at startup
    window.openDialog("chrome://piggy-bank/content/options-dialog.xul", "", "chrome,modal,dialog,width=500,height=400");
};

PB_Commands.resaveToBanks = function() {
	PiggyBank.checkBeforeExecuting(function() {
	    try {
	        PB_Extension.getPiggyBank().resaveToBanks();
	        alert("All data has been resaved.");
	    } catch (e) {
	        alert("Failed to save your data to your banks: " + e);
	    }
	});
};


