var CombineDialog = {};

CombineDialog.startup = function() {
    try {
        var list = document.getElementById("piggyBank-source-names");
        var sourceNames = PB_Extension.getPiggyBank().getPiggyBankServer().getSourceNames();
        var i = sourceNames.iterator();
        
        while (i.hasNext()) {
            var sourceName = i.next();
            
            list.appendItem(sourceName, sourceName);
        }
    } catch (e) {
        PB_Debug.onCaughtException(e);
    }
}

CombineDialog.OK = function() {
    try {
        var list = document.getElementById("piggyBank-source-names");
        var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
            .getService(Components.interfaces.nsIPromptService);
            
        if (list.selectedCount < 2) {
            promptService.alert(window, "Piggy Bank", "You must specify more than one source to combine.");
            return;
        }
        
        var selectedItems = list.selectedItems;
        var sourceNames = [];
        
        for (i = 0; i < selectedItems.length; i++) {
            sourceNames.unshift(selectedItems[i].value);
        }
        
        var profile = PB_Extension.getPiggyBank().getPiggyBankServer().defineComboProfile(sourceNames);

        PB_Extension.browseProfileInNewWindow(profile.getID(), window.opener.content);
        
        setTimeout(close, 100);
    } catch (e) {
        PB_Debug.onCaughtException(e);
    }
}

CombineDialog.Cancel = function() {
    setTimeout("close();", 100);
}


