var WelcomeWizard = {};

WelcomeWizard.startup = function() {
    PB_Debug.trace("welcome-wizard.js","> startup");

    WelcomeWizard._wizard = document.getElementById("welcome-wizard");
    
    var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);

    if (prefs.getPrefType(PB_Preferences.idForGeneratingTagURIs) == Components.interfaces.nsIPrefBranch.PREF_STRING) {
        var idForGeneratingTagURIs = prefs.getCharPref(PB_Preferences.idForGeneratingTagURIs);
        PB_Debug.trace("welcome-wizard.js","id found: " + idForGeneratingTagURIs);
        document.getElementById('email-textbox').value = idForGeneratingTagURIs;
        WelcomeWizard.encodeEmail();
    }

    if (prefs.getPrefType(PB_Preferences.googleKey) == prefs.PREF_STRING) {
        var googleKey = prefs.getCharPref(PB_Preferences.googleKey);
        PB_Debug.trace("welcome-wizard.js","google key found: " + googleKey);
        document.getElementById('googlekey').value = googleKey;
    }

    if (prefs.getPrefType(PB_Preferences.port) == Components.interfaces.nsIPrefBranch.PREF_INT) {
        var port = prefs.getIntPref(PB_Preferences.port);
        PB_Debug.trace("welcome-wizard.js","port found: " + googleKey);
        document.getElementById('port-textbox').value = port;
    } else {
        PB_Debug.trace("welcome-wizard.js","port not found, setting default (" +  + ")");
        document.getElementById('port-textbox').value = PB_Extension.default_port;
    }

    if (prefs.getPrefType(PB_Preferences.port) == prefs.PREF_STRING) {
        var googleKey = prefs.getCharPref(PB_Preferences.googleKey);
        PB_Debug.trace("welcome-wizard.js","google key found: " + googleKey);
        document.getElementById('googlekey').value = googleKey;
    }
    
    PB_Debug.trace("welcome-wizard.js","< startup");
};

WelcomeWizard._askCancel = true;
WelcomeWizard.cancel = function() {
    PB_Debug.trace("welcome-wizard.js","> cancel");
    
    var r = true;

    if (WelcomeWizard._askCancel) {
        var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
        r = promptService.confirm(
            window,
            "Piggy Bank",
            "Piggy Bank will not work if you quit now. Are you sure you want to quit?"
        );
    }
    
    PB_Debug.trace("welcome-wizard.js","< cancel");
    
    return r;
};

WelcomeWizard.finish = function() {
    PB_Debug.trace("welcome-wizard.js","> finish");
    
    var results = window.arguments[1];
    results.showDoc = document.getElementById('show-doc-checkbox').checked;
    results.showButton = document.getElementById('show-button-checkbox').checked;
    
    PB_Debug.trace("welcome-wizard.js","< finish");
    return true;
}

WelcomeWizard.link = function(anchor) {
	window.opener.openDialog(
		"chrome://browser/content/browser.xul", 
		"_blank", 
		"chrome,all,dialog=no,modal=no", 
		anchor.getAttribute("link")
	);
};

WelcomeWizard.encodeEmail = function() {
    var emailTextbox = document.getElementById('email-textbox');
    var encodedTextbox = document.getElementById('encoded-textbox');
    var email = emailTextbox.value;
    if (email != "") {
        encodedTextbox.value = hex_md5(email);
        WelcomeWizard._wizard.canAdvance = true;
    } else {
        encodedTextbox.value = "";
        WelcomeWizard._wizard.canAdvance = false;
    }
}

WelcomeWizard.onEmailPageAdvanced = function() {
    PB_Debug.trace("welcome-wizard.js","> onEmailPageAdvanced");
    
    var r = true;
    var textbox = document.getElementById('email-textbox');
    var idForGeneratingTagURIs = textbox.value;
    if (idForGeneratingTagURIs.indexOf("@") < 1) {
        alert("Please enter a valid e-mail address.");
        textbox.select();
        r = false;
    } else {
        var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
        PB_Debug.trace("welcome-wizard.js","e-mail: " + idForGeneratingTagURIs);
        prefs.setCharPref(PB_Preferences.idForGeneratingTagURIs, idForGeneratingTagURIs);
    }    
	
	if (r && WelcomeWizard._checkPort()) {
		WelcomeWizard._wizard.getPageById('email-page').next = 'maps-page';
	}
    
    PB_Debug.trace("welcome-wizard.js","< onEmailPageAdvanced");
    return r;
}


WelcomeWizard._checkPort = function() {
    var textbox = document.getElementById('port-textbox');
    var port = parseInt(textbox.value);
    var r = false;
    
    if (port > 1028) {
    	if (!PB_BrowserUtilities.isPortInUse(port)) {
            var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
            PB_Debug.trace("welcome-wizard.js","port: " + port);
            prefs.setIntPref(PB_Preferences.port, port);
            
    		r = true;
    	}
    }
    return r;
}

WelcomeWizard.onPortPageAdvanced = function() {
    PB_Debug.trace("welcome-wizard.js","> onPortPageAdvanced");

    var r = true;
    if (!WelcomeWizard._checkPort()) {
        alert("The port number must be greater than 1028 and not already in use. Please try another one.");
        
        var textbox = document.getElementById('port-textbox');
        textbox.select();
        
        r = false;
    }
    
    PB_Debug.trace("welcome-wizard.js","< onPortPageAdvanced");
    return r;
}

WelcomeWizard.onMapsPageShow = function() {
    PB_Debug.trace("welcome-wizard.js","> onMapsPageShow");
    
    var urlTextbox = document.getElementById('personalPBURL')
    urlTextbox.value = 
        "http://127.0.0.1:" +
        document.getElementById('port-textbox').value +
        "/piggy-bank/" + 
        document.getElementById('encoded-textbox').value + 
        "/resources/content/panes/map/";
    urlTextbox.select();
    
    PB_Debug.trace("welcome-wizard.js","< onMapsPageShow");
}

WelcomeWizard.onMapsPageAdvanced = function() {
    PB_Debug.trace("welcome-wizard.js","> onMapsPageAdvanced");

    var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
    var key = document.getElementById('googlekey').value;
    PB_Debug.trace("welcome-wizard.js","google key: " + key);
    prefs.setCharPref(PB_Preferences.googleKey, key);
    
    PB_Debug.trace("welcome-wizard.js","< onMapsPageAdvanced");
    return true;
}

WelcomeWizard._loaded = false;
WelcomeWizard._tasksCompleted = 0;
WelcomeWizard._running_on_mac = /[M|m]ac.*/.test(navigator.platform);

WelcomeWizard.onInitPageAdvanced = function() {
    PB_Debug.trace("welcome-wizard.js","> onInitPageAdvanced");
    
    if (!WelcomeWizard._loaded) {
        if (!WelcomeWizard._running_on_mac) {
            PB_Debug.trace("welcome-wizard.js","not running on mac, initializing progress feedback");

            var page = document.getElementById('init-page');

            var listbox = document.createElement("listbox");
            listbox.id = "tasks-list";
            listbox.flex = "1";
            listbox.disabled = "true";
            page.appendChild(listbox);
    
            var progressmeter = document.createElement("progressmeter");
            progressmeter.id = "progress";
            progressmeter.mode = "determined";
            page.appendChild(progressmeter);
        
            WelcomeWizard._taskCount = PB_Extension.fillTasks(listbox);
            listbox.focus();
        } else {
            PB_Debug.trace("welcome-wizard.js","running on mac, skipping progress feedback");

            var description = document.getElementById('mac-warning');
            description.collapsed = false;
        }

        var wizard = document.getElementById('welcome-wizard');
        wizard.canAdvance  = false;
        wizard.canRewind  = false;
        
        var previous_version = window.arguments[0];
        
        // kick-off the starting
        var progress = {
            taskCompleted : WelcomeWizard._taskCompleted,
            done : WelcomeWizard._doneTasks,
            fail : WelcomeWizard._failTasks
        };
        setTimeout(
            function() {
                PiggyBank.start(progress,previous_version);
            }, 50
        );
    }    
    
    PB_Debug.trace("welcome-wizard.js","< onInitPageAdvanced");
    
    return WelcomeWizard._loaded;
}

// -------------------------------------------------------------------

WelcomeWizard._taskCompleted = function() {
    PB_Debug.trace("welcome-wizard.js","> _taskCompleted");
    
    var listbox = document.getElementById('tasks-list');
    
    if (listbox) {
        var item = listbox.getItemAtIndex(WelcomeWizard._tasksCompleted);
        item.checked = true;
    }

    WelcomeWizard._tasksCompleted++;

    if (listbox) {
        if (WelcomeWizard._tasksCompleted < WelcomeWizard._taskCount) {
            try {
                listbox.selectItem(WelcomeWizard._tasksCompleted);
                listbox.ensureIndexIsVisible(WelcomeWizard._tasksCompleted);
            } catch (e) {
                // ignore the exception that firefox sometimes throws (one of their bugs)
            }
        }
    }
    
    var progress = document.getElementById('progress');
    if (progress) {
        progress.value = WelcomeWizard._tasksCompleted * 100 / WelcomeWizard._taskCount;
    }

    PB_Debug.trace("welcome-wizard.js","< _taskCompleted");
}

WelcomeWizard._doneTasks = function() {
    PB_Debug.trace("welcome-wizard.js","> _doneTask");
    
    WelcomeWizard._loaded = true;
    
    var wizard = document.getElementById('welcome-wizard');
    wizard.canAdvance = true;
    wizard.advance();
    
    WelcomeWizard._askCancel = false;
    
    PB_Debug.trace("welcome-wizard.js","< _doneTask");
}

WelcomeWizard._failTasks = function(e) {
    PB_Debug.trace("welcome-wizard.js","> _failTask");

    PiggyBank.showErrorPage(e,"configuring");
    
    WelcomeWizard._askCancel = false;
    
    var wizard = document.getElementById('welcome-wizard');
    wizard.cancel();    
    
    PB_Debug.trace("welcome-wizard.js","< _failTask");
}

WelcomeWizard.onLastPageShow = function() {
    PB_Debug.trace("welcome-wizard.js","> onLastPageShow");
    
    var wizard = document.getElementById('welcome-wizard');
    wizard.getButton("cancel").disabled = true;
    wizard.canRewind = false;
    
    PB_Debug.trace("welcome-wizard.js","< onLastPageShow");
}
