var PB_Extension = {}

PB_Extension.getPB_ExtensionName = function() {
    return "piggy-bank";
};

PB_Extension.default_port = 1978;

// ------------------------- java functions -------------------------
        
PB_Extension.browseProfile = function(id, tabBrowser, browser) {
    PB_Debug.trace("extension.js","> PB_Extension.browseProfile");
    var url = PB_Extension.getPiggyBank().getURL();
    if (url) {
        browser.contentWindow.location = url + id;
    }
    PB_Debug.trace("extension.js","< PB_Extension.browseProfile");
}

PB_Extension.browseProfileInNewWindow = function(id, w) {
    PB_Debug.trace("extension.js","> PB_Extension.browseProfileInNewWindow");
    var url = PB_Extension.getPiggyBank().getURL();
    if (url) {
        w.openDialog("chrome://browser/content/browser.xul", 
            "_blank", "chrome,all,dialog=no", url + id, null, null);
    }
    PB_Debug.trace("extension.js","< PB_Extension.browseProfileInNewWindow");
}

PB_Extension.getPiggyBankURL = function() {
    PB_Debug.trace("extension.js","PB_Extension.getPiggyBankURL");
    var pb = PB_Extension.getPiggyBank();
    if (pb) {
        return PB_Extension.getPiggyBank().getURL();
    }
}

PB_Extension.getPiggyBankPort = function() {
    PB_Debug.trace("extension.js","PB_Extension.getPiggyBankPort");
    var pb = PB_Extension.getPiggyBank();
    if (pb) {
        return PB_Extension.getPiggyBank().getPort();
    }
}

PB_Extension.getPiggyBankServer = function() {
    PB_Debug.trace("extension.js","PB_Extension.getPiggyBankServer");
    var pb = PB_Extension.getPiggyBank();
    if (pb) {
        return PB_Extension.getPiggyBank().getPiggyBankServer();
    }
}

PB_Extension.loadProfile = function(url, title, linkURLs, mimeTypes, relations) {
    PB_Debug.trace("extension.js","PB_Extension.loadProfile");
    var pb = PB_Extension.getPiggyBank();
    if (pb) {
        return PB_Extension.getPiggyBank().loadProfile(url, title, linkURLs, mimeTypes, relations)
    }
}

// ----------------------------------------------------------------------------

PB_Extension.setLoading = function(loading) {
    PB_Debug.trace("extension.js","PB_Extension.setLoading: " + loading);
    PB_Extension.getPiggyBankComponent().wrappedJSObject.loading = loading;
}    

PB_Extension.setClassloaderTracing = function(tracing) {
    PB_Debug.trace("extension.js","PB_Extension.setClassloaderTracing: " + tracing);
    PB_Extension.getPiggyBankComponent().wrappedJSObject.setClassloaderTracing(tracing);
}    

PB_Extension.setJavaTracing = function(tracing) {
    PB_Debug.trace("extension.js","PB_Extension.setJavaTracing: " + tracing);
    PB_Extension.getPiggyBankComponent().wrappedJSObject.setJavaTracing(tracing);
}    

PB_Extension.setGoogleKey = function(key) {
    PB_Debug.trace("extension.js","PB_Extension.setGoogleKey: " + key);
    PB_Extension.getPiggyBankComponent().wrappedJSObject.setGoogleKey(key);
}    

PB_Extension.attemptedToLoad = function() {
    PB_Debug.trace("extension.js","PB_Extension.attemptedToLoad");
    return PB_Extension.getPiggyBankComponent().wrappedJSObject.attempted;
}    

PB_Extension.isLoading = function() {
    PB_Debug.trace("extension.js","PB_Extension.isLoading");
    return PB_Extension.getPiggyBankComponent().wrappedJSObject.loading;
}    

PB_Extension.isRunning = function() {
    PB_Debug.trace("extension.js","PB_Extension.isRunning");
    return PB_Extension.getPiggyBankComponent().wrappedJSObject.initialized;
}    

PB_Extension.getError = function() {
    PB_Debug.trace("extension.js","PB_Extension.getError");
    return PB_Extension.getPiggyBankComponent().wrappedJSObject.error;
}    

PB_Extension.getVersion = function() {
    PB_Debug.trace("extension.js","PB_Extension.getVersion");
    return PB_Extension.getPiggyBankComponent().wrappedJSObject.version;
}    

PB_Extension.showWizard = function(previous_version) {
    PB_Debug.trace("extension.js","PB_Extension.showWizard");
    return PB_Extension.getPiggyBankComponent().wrappedJSObject.showWizard(previous_version);
}    

PB_Extension.fillTasks = function(list) {
    PB_Debug.trace("extension.js","PB_Extension.fillTasks");
    return PB_Extension.getPiggyBankComponent().wrappedJSObject.fillTasks(list);
}    

PB_Extension.initialize = function (
        java, previous_version, port, 
        extensionPath, profilePath,
        idForGeneratingTagURIs, googleKey,
        traceClassloader, traceJava,
        piggybankClasses,longwellClasses,
        progress
) {
    PB_Extension.getPiggyBankComponent().wrappedJSObject.initialize(
        java, previous_version, port, 
        extensionPath, profilePath,
        idForGeneratingTagURIs, googleKey,
        traceClassloader, traceJava,
        piggybankClasses, longwellClasses,
        progress
    );
}

PB_Extension.dispose = function() {
    PB_Debug.trace("extension.js","PB_Extension.dispose");
    return PB_Extension.getPiggyBankComponent().wrappedJSObject.dispose();
}    

// ----------------------------------------------------------------------

// FIXME(SM) these two functions should be private only, as to make sure
// that there is a single point of failure

PB_Extension.getPiggyBank = function() {
    PB_Debug.trace("extension.js","PB_Extension.getPiggyBank");
    var pb = PB_Extension.getPiggyBankComponent();
    if (pb) {
        return pb.wrappedJSObject.getInstance();
    }
};

PB_Extension.getPiggyBankComponent = function() {
    PB_Debug.trace("extension.js","PB_Extension._getPiggyBankComponent");
    return Components.classes["@simile.mit.edu/piggy-bank;1"].getService(Components.interfaces.nsIPiggyBank);
};
