/*
 * The Piggy Bank Explore Pane
 */
var PiggyBankExplorePane = new Object();
PiggyBankExplorePane._registry = {};
PiggyBankExplorePane._urlToScraper = [];
PiggyBankExplorePane._urlToAugmentData = [];
PiggyBankExplorePane._updating = false;

function inspect(o) {
    window.openDialog("chrome://inspector/content/object.xul", "_blank", "chrome,all,dialog=no", o);
}

PiggyBankExplorePane.openPanes = function() {
    UserStudy.log("user\topen-explore-pane");
    document.getElementById("piggyBank-explorePane-gutter").hidden = true;
    document.getElementById("piggyBank-explorePane-splitter").hidden = false;
    document.getElementById("piggyBank-explorePane-and-gutter").hidden = false;
}

PiggyBankExplorePane.closePanes = function() {
    UserStudy.log("user\tclose-explore-pane");
    document.getElementById("piggyBank-explorePane-gutter").hidden = false;
    document.getElementById("piggyBank-explorePane-splitter").hidden = true;
    document.getElementById("piggyBank-explorePane-and-gutter").hidden = true;
}

PiggyBankExplorePane.onBrowserSelected = function(browser) {
    try {
        var deck = document.getElementById("piggyBank-explorePane-deck");
        
        var id = PiggyBank._getBrowserKey(browser);
        var entry = this._registry[id];
        if (!entry) {
            entry = {
                id : id,
                browser : browser,
                url : "",
                scraped : false
            };
            this._registry[id] = entry;
            
            var template = document.getElementById("piggyBank-explorePane-perBrowser-template");
            var pane = template.cloneNode(true);
            pane.id = id;
            pane.hidden = false;
            
            deck.appendChild(pane);
            
            UserStudy.log("system\tcreate-pane");
        }
        
        var children = deck.childNodes;
        for (var i = 0; i < children.length; i++) {
            pane = children[i];
            if (pane.id == id) {
                if (deck.selectedIndex != i) {
                    deck.selectedIndex = i;
                }
                
                break;
            }
        }
        
        
        var pane = document.getElementById(id);
        var url = browser.contentDocument.location.href;
        if (entry.url != url) {
            entry.url = url;
            entry.scraped = false;
            entry.detectedPages = false;
            
            PiggyBankExplorePane._restoreAutoScraper(entry);
            
            UserStudy.log("system\ton-new-document\t" + url);
        } else {
            UserStudy.log("system\ton-old-document\t" + url);
        }
        
        if (entry.browser.contentWindow.top.wrappedJSObject.AutoScraper == null) {
            entry.scraped = false;
        }
            
        if (entry.scraped) {
            UserStudy.log("system\treshow-old-explore-pane");
            pane.selectedIndex = 1;
        } else {
            UserStudy.log("system\tprepare-new-explore-pane");
            
            pane.selectedIndex = 0;
            PiggyBankExplorePane._scrapeResetUI(pane, entry);
            
            /*
             *  This exact page has already been scraped. Just restore
             *  the Explore pane as it was before.
             */
            if (entry.browser.contentWindow.top.wrappedJSObject.AutoScraper == null) {
                UserStudy.log("system\treapply-scraper-settings");
                
                PiggyBankExplorePane._urlToAugmentData[url] = null;
                PiggyBankExplorePane._reapplyScraperSettings(pane, entry);
            } else {
                var augmentData = PiggyBankExplorePane._urlToAugmentData[url];
                if (augmentData) {
                    UserStudy.log("system\tre-augment");
                
                    PiggyBankExplorePane._setScrapingUI(pane);
                    
                    entry.scraped = true;
                    entry.profileID = augmentData.profileID;
                    entry.augment = function(doc, items) {
                        entry.scraper.augment(doc, items, new PB_ScrapingUtilities()); 
                    }
                    entry.query = DynamicQuery.duplicateQuery(augmentData.dynamicQuery);
                    entry.query.facetInfos = [];
                    
                    entry.scraper.preparePage(function(){}, browser.contentDocument, new PB_ScrapingUtilities());
                    
                    var query = augmentData.dynamicQuery;
                    
                    PiggyBankExplorePane._preparePane(pane);
                    PiggyBankExplorePane._fetchStart(entry, entry.query, function() {
                        PiggyBankExplorePane._fetchUpdateSelection(entry, query);
                    });
                }
            }
        }
    } catch (e) {
        PB_Debug.onCaughtException(e);
    }
}

PiggyBankExplorePane.onBrowserClosed = function(browser) {
    UserStudy.log("system\tclose-browser");
    try {
        var deck = document.getElementById("piggyBank-explorePane-deck");
        
        var id = PiggyBank._getBrowserKey(browser);
        var entry = this._registry[id];
        if (entry) {
            var pane = document.getElementById(id);
            
            PiggyBankExplorePane.cleanUpScrapingUI(pane);
            
            deck.removeChild(pane);
            this._registry[id] = null;
        }
    } catch (e) {
        PB_Debug.onCaughtException(e);
    }
};

PiggyBankExplorePane.onDataDetected = function(browser) {
    UserStudy.log("system\tdata-detected");
    
    var id = PiggyBank._getBrowserKey(browser);
    var entry = this._registry[id];
    if (entry && !entry.scraped) {
        UserStudy.log("system\treapply-scraper-settings");
        
        var pane = document.getElementById(entry.id);
        PiggyBankExplorePane._reapplyScraperSettings(pane, entry);
    }
}

PiggyBankExplorePane._restoreAutoScraper = function(entry) {
    var scraper = PiggyBankExplorePane._urlToScraper[PiggyBankExplorePane._getBaseURL(entry.url)];
    if (!scraper) {
        scraper = new AutoScraper();
    }
    entry.scraper = scraper;
};

PiggyBankExplorePane._saveAutoScraper = function(entry) {
    PiggyBankExplorePane._urlToScraper[PiggyBankExplorePane._getBaseURL(entry.url)] = entry.scraper;
};

PiggyBankExplorePane._getBaseURL = function(url) {
    var i = url.indexOf("?");
    return i > 0 ? url.substr(0, i) : url;
}

PiggyBankExplorePane._fetchStart = function(entry, query, cont) {
    var url = PB_Extension.getPiggyBank().getURL() + entry.profileID + "?command=explore&fetch=start";
    var body = DynamicQuery.writeXML(query);
    
    var onStatus = function(status, statusText, xmlhttp) {
        alert(status);
    };
    
    var onDone = function(responseText, xmlhttp) {
        PiggyBankExplorePane._processStart(entry, responseText);
        if (cont) {
            cont();
        }
    };
    
    PB_HTTPUtilities.doPost(url, body, onStatus, onDone);
};

PiggyBankExplorePane._fetchPage = function(entry, query, page) {
    var query2 = DynamicQuery.duplicateQuery(query);
    query2.pageIndex = page;
    
    var url = PB_Extension.getPiggyBank().getURL() + entry.profileID + "?command=explore&fetch=page";
    var body = DynamicQuery.writeXML(query2);
    
    var onStatus = function(status, statusText, xmlhttp) {
        alert(status);
    };
    
    var onDone = function(responseText, xmlhttp) {
        PiggyBankExplorePane._processPage(entry, responseText);
    };
    
    PB_HTTPUtilities.doPost(url, body, onStatus, onDone);
};

PiggyBankExplorePane._fetchAddFacets = function(entry, query, propertyURIs) {
    var url = PB_Extension.getPiggyBank().getURL() + entry.profileID + "?command=explore&fetch=add-facets&propertyURIs=" + encodeURIComponent(propertyURIs);
    var body = DynamicQuery.writeXML(query);
    
    var onStatus = function(status, statusText, xmlhttp) {
        alert(status);
    };
    
    var onDone = function(responseText, xmlhttp) {
        PiggyBankExplorePane._processAddFacets(entry, responseText);
    };
    
    PB_HTTPUtilities.doPost(url, body, onStatus, onDone);
};

PiggyBankExplorePane._fetchMoreFacetInfo = function(entry, query) {
    var url = PB_Extension.getPiggyBank().getURL() + entry.profileID + "?command=explore&fetch=more-facet-info";
    var body = DynamicQuery.writeXML(query);
    
    var onStatus = function(status, statusText, xmlhttp) {
        alert(status);
    };
    
    var onDone = function(responseText, xmlhttp) {
        PiggyBankExplorePane._processMoreFacetInfo(entry, responseText);
    };
    
    PB_HTTPUtilities.doPost(url, body, onStatus, onDone);
};

PiggyBankExplorePane._fetchReconstructSelection = function(entry, query) {
    var url = PB_Extension.getPiggyBank().getURL() + entry.profileID + "?command=explore&fetch=update-selection";
    var body = DynamicQuery.writeXML(query);
    
    var onStatus = function(status, statusText, xmlhttp) {
        alert(status);
    };
    
    var onDone = function(responseText, xmlhttp) {
        PiggyBankExplorePane._processUpdateSelection(entry, responseText);
    };
    
    PB_HTTPUtilities.doPost(url, body, onStatus, onDone);
};

PiggyBankExplorePane._fetchUpdateSelection = function(entry, query) {
    query.pageIndex = 0;
    PiggyBankExplorePane._fetchReconstructSelection(entry, query);
};

PiggyBankExplorePane._saveAugmentData = function(entry) {
    var augmentData = {
        profileID:      entry.profileID,
        dynamicQuery:   entry.query
    };
    PiggyBankExplorePane._urlToAugmentData[entry.url] = augmentData;
}

PiggyBankExplorePane._processStart = function(entry, scripts) {
    eval(scripts);
    
    entry.items = results.items;
    entry.query = results.query;
    entry.totalItemCount = results.itemCount;
    entry.totalPageCount = results.pageCount;
    entry.itemCount = results.itemCount;
    entry.pageCount = results.pageCount;
    
    var pane = document.getElementById(entry.id);
    pane.selectedIndex = 1;
    
    PiggyBankExplorePane._populateCount(pane, entry);
    PiggyBankExplorePane._populatePages(pane, entry);
    PiggyBankExplorePane._setButtons(pane, entry);
    PiggyBankExplorePane._preparePane(pane);
    
    PiggyBankExplorePane._updateAllFacetInfos(pane, entry, results.query.facetInfos);
    
    entry.augment(entry.browser.contentDocument, entry.items);
    
    PiggyBankExplorePane._saveAugmentData(entry);
}

PiggyBankExplorePane._processPage = function(entry, scripts) {
    eval(scripts);
    
    entry.items = results.items;
    entry.query.pageIndex = results.pageIndex;
    
    var pane = document.getElementById(entry.id);
    
    PiggyBankExplorePane._populatePages(pane, entry);
    PiggyBankExplorePane._setButtons(pane, entry);
    
    entry.augment(entry.browser.contentDocument, entry.items);
    
    PiggyBankExplorePane._saveAugmentData(entry);
};

PiggyBankExplorePane._processAddFacets = function(entry, scripts) {
    eval(scripts);
    
    var pane = document.getElementById(entry.id);
    
    PiggyBankExplorePane._updateAllFacetInfos(pane, entry, results.query.facetInfos);
    
    PiggyBankExplorePane._saveAugmentData(entry);
};

PiggyBankExplorePane._processMoreFacetInfo = function(entry, scripts) {
    eval(scripts);
    
    var pane = document.getElementById(entry.id);
    
    PiggyBankExplorePane._updateAllFacetInfos(pane, entry, results.query.facetInfos);
    
    PiggyBankExplorePane._saveAugmentData(entry);
}

PiggyBankExplorePane._processUpdateSelection = function(entry, scripts) {
    eval(scripts);
    
    var pane = document.getElementById(entry.id);
    
    PiggyBankExplorePane._updateAllFacetInfos(pane, entry, results.query.facetInfos);
    
    entry.items = results.items;
    entry.query = results.query;
    entry.itemCount = results.itemCount;
    entry.pageCount = results.pageCount;
    
    PiggyBankExplorePane._populateCount(pane, entry);
    PiggyBankExplorePane._populatePages(pane, entry);
    PiggyBankExplorePane._setButtons(pane, entry);
    
    entry.augment(entry.browser.contentDocument, entry.items);
    
    PiggyBankExplorePane._saveAugmentData(entry);
}

PiggyBankExplorePane._populatePages = function(pane, entry) {
    var id = entry.id;
    
    var vbox = pane.childNodes[1];
    var hbox = vbox.childNodes[2];
    
    var pageIndex = entry.query.pageIndex;
    var pageCount = entry.pageCount;

    if (pageCount < 2) {
        hbox.hidden = true;
    } else {
        hbox.hidden = false;
        while (hbox.firstChild) {
            hbox.removeChild(hbox.firstChild);
        }
    
        var label = document.createElement("label");
        label.setAttribute("value", "Pages:");
        hbox.appendChild(label);
        
        var insertPageLink = function(i) {
            var label = document.createElement("label");
            if (i == pageIndex) {
                label.className = "piggyBank-explorePane-currentPage";
                label.setAttribute("value", "[" + (i + 1) + "]");
            } else {
                var value = (i == 0) ? "<< 1" : ((i == pageCount - 1) ? pageCount + " >>" : (i + 1));
                label.setAttribute("value", value);
                label.className = "piggyBank-explorePane-pageLink";
                label.onclick = function() {
                    PiggyBankExplorePane.goToPage(id, i);
                }
            }
            hbox.appendChild(label);
        };
        var insertEllipses = function() {
            var label = document.createElement("label");
            label.setAttribute("value", "...");
            hbox.appendChild(label);
        };
        
        if (pageIndex >= 6) { 
            if (pageIndex <= pageCount - 7) { // ellipses at the beginning and the end
                for (var i = 0; i < 3; i++) {
                    insertPageLink(i);
                }
                insertEllipses();
                for (var i = pageIndex - 2; i < pageIndex + 3; i++) {
                    insertPageLink(i);
                }
                insertEllipses();
                for (var i = pageCount - 3; i < pageCount; i++) {
                    insertPageLink(i);
                }
            } else { // ellipses at the beginning only
                for (var i = 0; i < 3; i++) {
                    insertPageLink(i);
                }
                insertEllipses();
                for (var i = pageIndex - 2; i < pageCount; i++) {
                    insertPageLink(i);
                }
            }
        } else if (pageIndex <= pageCount - 7) { // ellipses at the end only
            for (var i = 0; i < pageIndex + 3; i++) {
                insertPageLink(i);
            }
            insertEllipses();
            for (var i = pageCount - 3; i < pageCount; i++) {
                insertPageLink(i);
            }
        } else { // no ellipses
            for (var i = 0; i < pageCount; i++) {
                insertPageLink(i);
            }
        }
    }
};

PiggyBankExplorePane._populateCount = function(pane, entry) {
    var hbox = pane.childNodes[1].childNodes[0];
    var label = hbox.firstChild;
    label.setAttribute("value", entry.itemCount);
    
    var hbox2 = label.nextSibling.firstChild.firstChild;
    while (hbox2.firstChild) {
        hbox2.removeChild(hbox2.firstChild);
    }
    
    if (entry.itemCount == entry.totalItemCount) {
        var label2 = document.createElement("label");
        label2.setAttribute("value", "items in total");
        hbox2.appendChild(label2);
    } else {
        var label2 = document.createElement("label");
        label2.setAttribute("value", "items filtered from");
        hbox2.appendChild(label2);
        
        label2 = document.createElement("label");
        label2.setAttribute("value", entry.totalItemCount + " original items");
        label2.className = "piggyBank-explorePane-link";
        label2.onclick = function() {
            PiggyBankExplorePane._updating = true;
            
            var clearSelected = function(values, recurse) {
                for (var i = 0; i < values.length; i++) {
                    var v = values[i];
                    v.selected = false;
                    if ("facetValues" in v && v.facetValues instanceof Array) {
                        recurse(v.facetValues, recurse);
                    }
                }
            };
            
            for (var i = 0; i < entry.query.facetInfos.length; i++) {
                clearSelected(entry.query.facetInfos[i].facetValues, clearSelected);
            }
                
            var facetContainerBox = pane.childNodes[1].childNodes[3].childNodes[1];
            var facetBoxes = facetContainerBox.childNodes;
            for (var i = 0; i < facetBoxes.length; i++) {
                var facetBox = facetBoxes[i];
                var tree = facetBox.firstChild.childNodes[3];
                
                tree.view.selection.clearSelection();
            }

            PiggyBankExplorePane._updating = false;
            
            PiggyBankExplorePane._fetchUpdateSelection(entry, entry.query);
        }
        
        hbox2.appendChild(label2);
    }
};

PiggyBankExplorePane._updateAllFacetInfos = function(pane, entry, newFacetInfos) {
    var facetContainerBox = pane.childNodes[1].childNodes[3].childNodes[1];
    
    var newPropertyURIs = [];
    
    var oldFacetInfos = entry.query.facetInfos;
    for (var i = 0; i < newFacetInfos.length; i++) {
        var newFacetInfo = newFacetInfos[i];
        
        var j = 0;
        while (j < oldFacetInfos.length) {
            var oldFacetInfo = oldFacetInfos[j];
            if (oldFacetInfo.propertyURI == newFacetInfo.propertyURI) {
                break;
            }
            j++;
        }
        
        if (j < oldFacetInfos.length) {
            PiggyBankExplorePane._updateFacetInfo(entry, oldFacetInfos[j], newFacetInfo, facetContainerBox);
            oldFacetInfos[j] = newFacetInfo;
        } else {
            PiggyBankExplorePane._createFacetInfo(entry, newFacetInfo, facetContainerBox);
            oldFacetInfos.push(newFacetInfo);
            newPropertyURIs.push(newFacetInfo.propertyURI);
        }
    }
    
    if (newPropertyURIs.length > 0) {
        PiggyBankExplorePane._highlightSmartTagsAndFacetBoxes(entry, pane, newPropertyURIs);
    }
};

PiggyBankExplorePane._setButtons = function(pane, entry) {
    var vbox = pane.childNodes[1];
    var buttonsHbox = vbox.childNodes[0].childNodes[1].childNodes[1];
    var previous = buttonsHbox.childNodes[0];
    var next = buttonsHbox.childNodes[1];
    
    previous.disabled = (entry.query.pageIndex == 0);
    previous.setAttribute("label", "<< Previous " + entry.query.itemsPerPage);
    
    next.disabled = (entry.query.pageIndex == entry.pageCount - 1);
    next.setAttribute("label", "Next " + entry.query.itemsPerPage + " >>");
};

PiggyBankExplorePane._updateFacetInfo = function(entry, oldFacetInfo, newFacetInfo, facetContainerBox) {
    var node = facetContainerBox.firstChild;
    while (node) {
        if (node.getAttribute("propertyURI") == newFacetInfo.propertyURI) {
            break;
        }
        node = node.nextSibling;
    }
    
    newFacetInfo.treeView = oldFacetInfo.treeView;
    newFacetInfo.treeView.update(newFacetInfo);
    
    if (node) {
        var tree = node.firstChild.childNodes[3];
        tree.onselect = function(evt) {
            PiggyBankExplorePane.onFacetTreeSelect(entry, newFacetInfo, tree, evt);
        }
    }
};

PiggyBankExplorePane._createFacetInfo = function(entry, facetInfo, facetContainerBox) {
    UserStudy.log("user\topen-facet\t" + facetInfo.propertyURI);
            
    var pane = document.getElementById(entry.id);
    var view = new FacetTreeView(facetInfo, entry.id);
    facetInfo.treeView = view;
    
    var propertyURI = facetInfo.propertyURI;
    
    var deck = facetContainerBox.parentNode.nextSibling.nextSibling.cloneNode(true);
    deck.setAttribute("propertyURI", propertyURI);
    deck.hidden = false;
    
        var vbox = deck.firstChild;
        vbox.onmouseover = function(evt) {
            PiggyBankExplorePane._highlightSmartTagsAndFacetBoxes(entry, pane, [ propertyURI ]);
        };
        
            var hbox = vbox.firstChild.firstChild.childNodes[1];
            var asc = hbox.childNodes[0];
            var desc = hbox.childNodes[1];
            var orig = hbox.childNodes[2];
            
            asc.onclick = function(evt) {
                PiggyBankExplorePane.sort(entry, propertyURI, true);
            }
            desc.onclick = function(evt) {
                PiggyBankExplorePane.sort(entry, propertyURI, false);
            }
            orig.onclick = function(evt) {
                PiggyBankExplorePane.sort(entry, "http://simile.mit.edu/2005/04/piggy-bank#original-order", true);
            }
            
            if (entry.query.sortPropertyURI == propertyURI) {
                asc.disabled = entry.query.sortAscending;
                desc.disabled = !entry.query.sortAscending;
                orig.disabled = false;
            }
            
            vbox.childNodes[0].childNodes[1].onclick = function(evt) {
                PiggyBankExplorePane.collapseFacet(entry, propertyURI);
            }
            vbox.childNodes[0].childNodes[2].onclick = function(evt) {
                PiggyBankExplorePane.closeFacet(entry, propertyURI);
            }
            vbox.childNodes[2].childNodes[2].onclick = function(evt) {
                PiggyBankExplorePane.unselectValues(entry, propertyURI);
            }
            
            var tree = vbox.childNodes[3];
            tree.view = view;
            tree.onselect = function(evt) {
                PiggyBankExplorePane.onFacetTreeSelect(entry, facetInfo, tree, evt);
            };
            
        vbox = vbox.nextSibling;
        vbox.onmouseover = function(evt) {
            PiggyBankExplorePane._highlightSmartTagsAndFacetBoxes(entry, pane, [ propertyURI ]);
        };
        
            vbox.childNodes[0].onclick = function(evt) {
                PiggyBankExplorePane.expandFacet(entry, propertyURI);
            }
            vbox.childNodes[1].onclick = function(evt) {
                PiggyBankExplorePane.closeFacet(entry, propertyURI);
            }
            
    facetContainerBox.appendChild(deck);
    PiggyBankExplorePane.hideFacetHints(pane);

    setTimeout(function() { view.reselect(); }, 0);
};

PiggyBankExplorePane._preparePane = function(pane) {
    UserStudy.log("system\tprepare-pane");

    var facetContainerBox = pane.childNodes[1].childNodes[3].childNodes[1];
    while (facetContainerBox.firstChild) {
        facetContainerBox.removeChild(facetContainerBox.firstChild);
    }
    PiggyBankExplorePane.showFacetHints(pane);
};

PiggyBankExplorePane.nextPage = function(elmt) {
    UserStudy.log("user\tnext-page");
    
    var pane = elmt.parentNode.parentNode.parentNode.parentNode.parentNode;
    var entry = PiggyBankExplorePane._registry[pane.id];
    
    PiggyBankExplorePane._fetchPage(entry, entry.query, entry.query.pageIndex + 1);
};

PiggyBankExplorePane.previousPage = function(elmt) {
    UserStudy.log("user\tprevious-page");
    
    var pane = elmt.parentNode.parentNode.parentNode.parentNode.parentNode;
    var entry = PiggyBankExplorePane._registry[pane.id];
    
    PiggyBankExplorePane._fetchPage(entry, entry.query, entry.query.pageIndex - 1);
};

PiggyBankExplorePane.goToPage = function(id, pageIndex) {
    UserStudy.log("user\tgo-to-page\t" + pageIndex);
    
    var entry = PiggyBankExplorePane._registry[id];
    PiggyBankExplorePane._fetchPage(entry, entry.query, pageIndex);
};

PiggyBankExplorePane.hoverSmartTag = function(id, propertyURIs) {
    UserStudy.log("user\thover-smart-tag\t" + propertyURIs);
    
    var entry = PiggyBankExplorePane._registry[id];
    var pane = document.getElementById(id);
    
    PiggyBankExplorePane._highlightSmartTagsAndFacetBoxes(entry, pane, propertyURIs.split("\n"));
}

PiggyBankExplorePane.selectSmartTag = function(id, propertyURIs) {
    UserStudy.log("user\tselect-smart-tag\t" + propertyURIs);

    var entry = PiggyBankExplorePane._registry[id];
    var pane = document.getElementById(id);
    
    propertyURIs = propertyURIs.split("\n");
    var newPropertyURIs = [];
    var oldPropertyURIs = [];
    
    var facetContainerBox = pane.childNodes[1].childNodes[3].childNodes[1];
    var facetBoxes = facetContainerBox.childNodes;
    for (var i = 0; i < propertyURIs.length; i++) {
        var propertyURI = propertyURIs[i];
        
        var j = 0;
        while (j < facetBoxes.length) {
            if (facetBoxes[j].getAttribute("propertyURI") == propertyURI) {
                break;
            }
            j++;
        }
        
        if (j < facetBoxes.length) {
            oldPropertyURIs.push(propertyURI);
        } else {
            newPropertyURIs.push(propertyURI);
        }
    }
    
    if (newPropertyURIs.length > 0) {
        PiggyBankExplorePane._fetchAddFacets(entry, entry.query, newPropertyURIs.join("\n"));
    }
}

PiggyBankExplorePane._highlightSmartTagsAndFacetBoxes = function(entry, pane, propertyURIs) {
    var doc = entry.browser.contentDocument;
    var smartTags = doc.getElementsByName("piggyBank-smartTag");
    
    for (var i = 0; i < smartTags.length; i++) {
        var smartTag = smartTags[i];
        var propertyURIs2 = smartTag.getAttribute("propertyURIs").split("\n");
        
        var found = false;
        outer:for (var x = 0; x < propertyURIs.length; x++) {
            var propertyURI = propertyURIs[x];
            
            var j = 0;
            while (j < propertyURIs2.length) {
                if (propertyURIs2[j] == propertyURI) {
                    found = true;
                    break outer;
                }
                j++;
            }
        }
        
        if (found) {
            smartTag.setAttribute("src", "chrome://piggy-bank/skin/smart-tag-hover.png");
        } else {
            smartTag.setAttribute("src", "chrome://piggy-bank/skin/smart-tag.png");
        }
    }
    
    var facetContainerBox = pane.childNodes[1].childNodes[3].childNodes[1];
    var facetBoxes = facetContainerBox.childNodes;
    
    for (var i = 0; i < facetBoxes.length; i++) {
        var facetBox = facetBoxes[i];
        var propertyURI = facetBox.getAttribute("propertyURI");
        
        var found = false;
        for (var x = 0; x < propertyURIs.length; x++) {
            if (propertyURI == propertyURIs[x]) {
                found = true;
                break;
            }
        }
        
        facetBox.childNodes[0].setAttribute("highlighted", found);
        facetBox.childNodes[1].setAttribute("highlighted", found);
        if (found) {
            UserStudy.log("system\thighlight-facet\t" + propertyURI);
            facetContainerBox.scrollBoxObject.ensureElementIsVisible(facetBox);
        }
    }
}

PiggyBankExplorePane.expandTargetedFacetValues = function(id) {
    var entry = PiggyBankExplorePane._registry[id];
    PiggyBankExplorePane._fetchMoreFacetInfo(entry, entry.query);
}

PiggyBankExplorePane.onFacetTreeSelect = function(entry, facetInfo, tree, evt) {
    if (!facetInfo.treeView.updating && !PiggyBankExplorePane._updating) {
        var view = tree.view;
        var selection = view.selection;
        
        var clearSelected = function(values, recurse) {
            for (var i = 0; i < values.length; i++) {
                var v = values[i];
                v.selected = false;
                if ("facetValues" in v && v.facetValues instanceof Array) {
                    recurse(v.facetValues, recurse);
                }
            }
        };
        clearSelected(facetInfo.facetValues, clearSelected);
        
        UserStudy.log("user\tselect-facet-values\t" + facetInfo.propertyURI + "\t" + selection.count);
        
        PiggyBankExplorePane._recurseUpdateFacetTreeSelection(view, selection, facetInfo.facetValues, 0);
        PiggyBankExplorePane._fetchUpdateSelection(entry, entry.query);
    }
}

PiggyBankExplorePane._recurseUpdateFacetTreeSelection = function(view, selection, facetValues, visibleRowIndex) {
    var selectDescendants = function(fv, recurse) {
        if (fv.facetValues) {
            for (var i = 0; i < fv.facetValues.length; i++) {
                var fv2 = fv.facetValues[i];
                fv2.selected = true;
                recurse(fv2, recurse);
            }
        }
    }
    var isDescendentSelected = function(row) {
        var level = view.getLevel(row);
        for (var r = row + 1; r < view.rowCount; r++) {
            if (view.getLevel(r) > level) {
                if (selection.isSelected(r)) {
                    return true;
                }
            } else {
                break;
            }
        }
        return false;
    }
    
    for (var i = 0; i < facetValues.length; i++) {
        var facetValue = facetValues[i];
        
        if (selection.isSelected(visibleRowIndex)) {
            facetValue.selected = true;
            if (view.isContainer(visibleRowIndex)) {
                if (!view.isContainerOpen(visibleRowIndex)) {
                    selectDescendants(facetValue, selectDescendants);
                } else if (!isDescendentSelected(visibleRowIndex)) {
                    selectDescendants(facetValue, selectDescendants);
                }
            }
        }
        
        if (view.isContainer(visibleRowIndex) && 
            view.isContainerOpen(visibleRowIndex) &&
            (facetValue.facetValues)) {
            
            visibleRowIndex = PiggyBankExplorePane._recurseUpdateFacetTreeSelection(
                view, selection, facetValue.facetValues, visibleRowIndex + 1);
        } else {
            visibleRowIndex++;
        }
    }
    return visibleRowIndex;
}

PiggyBankExplorePane.sort = function(entry, propertyURI, ascending) {
    UserStudy.log("user\tsort\t" + propertyURI + "\t" + ascending);

    var pane = document.getElementById(entry.id);
    var facetContainerBox = pane.childNodes[1].childNodes[3].childNodes[1];
    var facetBoxes = facetContainerBox.childNodes;
    
    for (var i = 0; i < facetBoxes.length; i++) {
        var facetBox = facetBoxes[i];
        var samePropertyURI = (propertyURI == facetBox.getAttribute("propertyURI"));
        
        var hbox = facetBox.firstChild.firstChild.firstChild.childNodes[1];
        var asc = hbox.childNodes[0];
        var desc = hbox.childNodes[1];
        var orig = hbox.childNodes[2];
        
        asc.disabled = samePropertyURI && ascending;
        desc.disabled = samePropertyURI && !ascending;
        orig.disabled = !samePropertyURI;
    }
    
    entry.query.sortPropertyURI = propertyURI;
    entry.query.sortAscending = ascending;
    
    PiggyBankExplorePane._fetchPage(entry, entry.query, 0);
}

PiggyBankExplorePane.unselectValues = function(entry, propertyURI) {
    UserStudy.log("user\tunselect-facet-values\t" + propertyURI);

    var pane = document.getElementById(entry.id);
    var facetContainerBox = pane.childNodes[1].childNodes[3].childNodes[1];
    var facetBoxes = facetContainerBox.childNodes;
    
    for (var i = 0; i < facetBoxes.length; i++) {
        var facetBox = facetBoxes[i];
        if (propertyURI == facetBox.getAttribute("propertyURI")) {
            var tree = facetBox.firstChild.childNodes[3];
            tree.view.selection.clearSelection();
            break;
        }
    }
}

PiggyBankExplorePane.expandFacet = function(entry, propertyURI) {
    UserStudy.log("user\texpand-facet\t" + propertyURI);

    var pane = document.getElementById(entry.id);
    var facetContainerBox = pane.childNodes[1].childNodes[3].childNodes[1];
    var facetBoxes = facetContainerBox.childNodes;
    
    for (var i = 0; i < facetBoxes.length; i++) {
        var facetBox = facetBoxes[i];
        if (propertyURI == facetBox.getAttribute("propertyURI")) {
            facetBox.childNodes[1].collapsed = true;
            facetBox.childNodes[0].collapsed = false;
            break;
        }
    }
}

PiggyBankExplorePane.collapseFacet = function(entry, propertyURI) {
    UserStudy.log("user\tcollapse-facet\t" + propertyURI);

    var pane = document.getElementById(entry.id);
    var facetContainerBox = pane.childNodes[1].childNodes[3].childNodes[1];
    var facetBoxes = facetContainerBox.childNodes;
    
    for (var i = 0; i < facetBoxes.length; i++) {
        var facetBox = facetBoxes[i];
        if (propertyURI == facetBox.getAttribute("propertyURI")) {
            facetBox.childNodes[0].collapsed = true;
            facetBox.childNodes[1].collapsed = false;
            break;
        }
    }
}

PiggyBankExplorePane.closeFacet = function(entry, propertyURI) {
    var pane = document.getElementById(entry.id);
    var facetContainerBox = pane.childNodes[1].childNodes[3].childNodes[1];
    var facetBoxes = facetContainerBox.childNodes;
    
    for (var i = 0; i < facetBoxes.length; i++) {
        var facetBox = facetBoxes[i];
        if (propertyURI == facetBox.getAttribute("propertyURI")) {
            var tree = facetBox.firstChild.childNodes[3];
            var ask = tree.view.selection.count > 0 || propertyURI == entry.query.sortPropertyURI;
            
            UserStudy.log("user\tclose-facet\t" + propertyURI + "\t" + tree.view.selection.count + "\t" + (propertyURI == entry.query.sortPropertyURI));
            
            //if (!ask || window.confirm("The items are currently sorted or filtered by this field.\nRemoving this field would remove its filter and sorting option. Continue?")) {
            if (true) {
                if (entry.query.sortPropertyURI == propertyURI) {
                    entry.query.sortPropertyURI = "http://simile.mit.edu/2005/04/piggy-bank#original-order";
                    entry.query.sortAscending = true;
                }
                
                for (var i = 0; i < entry.query.facetInfos.length; i++) {
                    if (entry.query.facetInfos[i].propertyURI == propertyURI) {
                        entry.query.facetInfos.splice(i, 1);
                        break;
                    }
                }
                
                facetContainerBox.removeChild(facetBox);
                if (entry.query.facetInfos.length == 0) {
                    PiggyBankExplorePane.showFacetHints(pane);
                }
                
                PiggyBankExplorePane._fetchUpdateSelection(entry, entry.query);
            }
            break;
        }
    }
}

PiggyBankExplorePane.showFacetHints = function(pane) {
    var deck = pane.childNodes[1].childNodes[3];
    deck.selectedIndex = 0;
}

PiggyBankExplorePane.hideFacetHints = function(pane) {
    var deck = pane.childNodes[1].childNodes[3];
    deck.selectedIndex = 1;
}

PiggyBankExplorePane.rescrape = function(elmt) {
    var pane = elmt.parentNode.parentNode.parentNode.parentNode.parentNode;
    var id = pane.id;
    var entry = PiggyBankExplorePane._registry[id];
    
    PiggyBankExplorePane._urlToAugmentData[entry.url] = null;
    entry.browser.reload();
}

PiggyBankExplorePane.showInPiggyBank = function(elmt) {
    var pane = elmt.parentNode.parentNode;
    var id = pane.id;
    var entry = PiggyBankExplorePane._registry[id];
    var url = PB_Extension.getPiggyBank().getURL() + entry.profileID + "?command=browse";
    entry.browser.contentDocument.location = url;
}
