function PB_ScrapingUtilities() {
    this.debugPrint = PB_Debug.print;
    this.HTTPUtilities = PB_HTTPUtilities;
}

PB_ScrapingUtilities.prototype.trimString = function(s) {
    var i = 0;
    var spaceChars = " \n\r\t" + String.fromCharCode(160) /* &nbsp; */;
    while (i < s.length) {
        var c = s.charAt(i);
        if (spaceChars.indexOf(c) < 0) {
            break;
        }
        i++;
    }
    
    s = s.substring(i);
    
    i = s.length;
    while (i > 0) {
        var c = s.charAt(i - 1);
        if (spaceChars.indexOf(c) < 0) {
            break;
        }
        i--;
    }
    
    return s.substring(0, i);
}

PB_ScrapingUtilities.prototype.gatherElementsOnXPath = function(doc, parentNode, xpath, nsResolver) {
	var elmts = [];
	
	var iterator = doc.evaluate(xpath, parentNode, nsResolver, XPathResult.ANY_TYPE,null);
	var elmt = iterator.iterateNext();
	var i = 0;
	while (elmt) {
		elmts[i++] = elmt;
		elmt = iterator.iterateNext();
	}
	return elmts;
}

PB_ScrapingUtilities.prototype.loadDocument = function(url, browser, succeeded, failed) {
    this.processDocuments(browser, null, [ url ], succeeded, function() {}, failed);
}

PB_ScrapingUtilities.prototype.processDocuments = function(browser, firstDoc, urls, processor, done, exception) {
    try {
        if (urls.length == 0) {
            if (firstDoc) {
                var canceled = false;
        
                processor(firstDoc, done, function() { canceled = true; });
                if (canceled) {
                    return;
                }
            } else {
                done();
            }
            return;
        }
        
        var wParent = window;
        var w = openDialog("chrome://piggy-bank/content/load-dom-dialog.xul", 
            "_blank", "chrome,all,dialog=no,centerscreen", null, null, null);
        
        var urlIndex = -1;
        var doLoad = function() {
            urlIndex++;
            if (urlIndex < urls.length) {
                try {
                    var url = urls[urlIndex];
                    var b = w.document.getElementById("hidden-browser");
                    b.loadURI(url);
                } catch (e) {
                    exception(e);
                    PB_Debug.print("processDocuments doLoad: " + e);
                }
            } else {
                try {
                    w.close();
                } catch (e) {
                    PB_Debug.print(e);
                }
                wParent.setTimeout(done, 10);
            }
        };
        var cancel = function() {
            try {
                w.close();
            } catch (e) {
                PB_Debug.print(e);
            }
        };
        var onLoad = function() {
            try {
                var list = w.document.getElementById("url-list");
                var item = list.getItemAtIndex(urlIndex);
                item.disabled = true;
                item.label = "Done - " + item.label;
                
                var progressmeter = w.document.getElementById("progress");
                var progress = (urlIndex * 100 / urls.length) + "";
                if (progress.indexOf(".") > 0) {
                    progress = progress.substr(0, progress.indexOf("."));
                }
                progressmeter.setAttribute("value", progress + "%");

                var b = w.document.getElementById("hidden-browser").selectedBrowser;
                processor(b.contentDocument, doLoad, cancel);
            } catch (e) {
                exception(e);
                PB_Debug.print("processDocuments onLoad: " + e);
            }
        };
        var init = function() {
            var list = w.document.getElementById("url-list");
            for (j = 0; j < urls.length; j++) {
                list.appendItem(urls[j], urls[j]);
            }
            
            var listener = PB_BrowserUtilities.createProgressListener();
            listener.onStateChange = function(webProgress, request, stateFlags, status) {
                if ((stateFlags & Components.interfaces.nsIWebProgressListener.STATE_STOP) > 0 &&
                    request.name == urls[urlIndex]) {
                    try {
                        w.setTimeout(onLoad, 10);
                    } catch (e) {
                        exception(e);
                        PB_Debug.print("processDocuments onLocationChange: " + e);
                    }
                }
            };
            
            var tb = w.document.getElementById("hidden-browser");
            tb.addProgressListener(listener, Components.interfaces.nsIWebProgress.NOTIFY_ALL);
            
            if (firstDoc) {
                processor(firstDoc, doLoad);
            } else {
                doLoad();
            }
        }
        
        w.addEventListener("load", init, false);
    } catch (e) {
        exception(e);
        PB_Debug.print("processDocuments: " + e);
    }
}

PB_ScrapingUtilities.prototype.processDocuments2 = function(browser, url, processor, done, exception) {
    try {
        var wParent = window;
        var w = openDialog("chrome://piggy-bank/content/load-dom-dialog2.xul", 
            "_blank", "chrome,all,dialog=no,centerscreen", null, null, null);
        
        var count = 0;
        var doLoad = function(url) {
            if (url != null) {
                try {
                    w.document.getElementById("url-label").setAttribute("value", url);
                    w.document.getElementById("count-label").setAttribute("value", count);
                    
                    var b = w.document.getElementById("hidden-browser");
                    b.loadURI(url);
                } catch (e) {
                    exception(e);
                    PB_Debug.print("processDocuments doLoad: " + e);
                }
            } else {
                try {
                    w.close();
                } catch (e) {
                    PB_Debug.print(e);
                }
                wParent.setTimeout(done, 10);
            }
        };
        var cancel = function() {
            try {
                w.close();
            } catch (e) {
                PB_Debug.print(e);
            }
        };
        var onLoad = function() {
            try {
                count++;
                var b = w.document.getElementById("hidden-browser").selectedBrowser;
                processor(b.contentDocument, doLoad, cancel);
            } catch (e) {
                exception(e);
                PB_Debug.print("processDocuments onLoad: " + e);
            }
        };
        var init = function() {
            var listener = PB_BrowserUtilities.createProgressListener();
            listener.onStateChange = function(webProgress, request, stateFlags, status) {
                if ((stateFlags & Components.interfaces.nsIWebProgressListener.STATE_STOP) > 0 &&
                    request.name == w.document.getElementById("url-label").getAttribute("value")) {
                    try {
                        w.setTimeout(onLoad, 10);
                    } catch (e) {
                        exception(e);
                        PB_Debug.print("processDocuments2 onLocationChange: " + e);
                    }
                }
            };
            
            var tb = w.document.getElementById("hidden-browser");
            tb.addProgressListener(listener, Components.interfaces.nsIWebProgress.NOTIFY_ALL);
            
            doLoad(url);
        }
        
        w.addEventListener("load", init, false);
    } catch (e) {
        exception(e);
        PB_Debug.print("processDocuments2: " + e);
    }
}

PB_ScrapingUtilities.prototype.collectURLsWithSubstring = function(doc, substring) {
    var urls = [];
    var addedURLs = [];
    
    var aElements = doc.evaluate("//a", doc, null, XPathResult.ANY_TYPE,null);
    var aElement = aElements.iterateNext();
    while (aElement) {
        var href = aElement.href;
        if (href.indexOf(substring) >= 0 && !(addedURLs[href])) {
            urls.unshift(href);
            addedURLs[href] = true;
        }
        aElement = aElements.iterateNext();
    }
    return urls;
}

PB_ScrapingUtilities.prototype.getLLsFromAddresses = function(keys, keyToAddress, succeeded, failed) {
    var w = openDialog("chrome://piggy-bank/content/address-dialog.xul", 
        "_blank", "chrome,dialog=no,centerscreen,width=375,height=120,resizable=no", null, null, null);
        
    var init = function(evt) {
        try {
            var cancelHandler = function(evt) { w.close(); };
            w.document.getElementById("cancel-button").addEventListener("command", cancelHandler, false);
            
            var url = PB_Extension.getPiggyBankURL() + "system/address";
            
            var body = "";  
            for (i = 0; i < keys.length; i++) {
                var key = keys[i];
                body = body + key.replace(/\&/g, "&amp;") + " " + keyToAddress[key] + "\n";
            }
            
            var onStatus = function(status, statusText, xmlhttp) {
                w.close();
                failed();
            };
            var onDone = function(responseText, xmlhttp) {
                if (!w.closed) {
                    w.setTimeout(function() { w.close(); }, 10);
                    
                    var keyToLL = [];
                    try {
                        var i = responseText.indexOf("\n") + 1; // skip over <results>
                        while (i < responseText.length) {
                            var space = responseText.indexOf(" ", i);
                            if (space < 0) {
                                break;
                            }
                            
                            var r = responseText.indexOf('\n', space);
                            if (r < 0) {
                                r = responseText.length;
                            }
                            
                            var key = responseText.substring(i, space).replace(/\&amp\;/g, "&");
                            var ll = responseText.substring(space + 1, r);
                            
                            keyToLL[key] = ll;
                                
                            i = r + 1;
                        }
                        
                        succeeded(keyToLL);
                    } catch(e) {
                        failed(e);
                    }
                }
            }
            
            PB_HTTPUtilities.doPost(url, body, onStatus, onDone);
        } catch (e) {
            alert(e);
        }
    }
    w.addEventListener("load", init, false);
}

function PB_ScrapingUtilities_GeoHelper(fProcessLL, utilities) {
	this._fProcessLL = fProcessLL;
	this._utilities = utilities;
	this._keys = [];
	this._keyToAddress = [];
}
PB_ScrapingUtilities_GeoHelper.prototype.add = function(key, address) {
	this._keys.unshift(key);
	this._keyToAddress[key] = address;
}
PB_ScrapingUtilities_GeoHelper.prototype.lookupAddresses = function(succeeded, failed) {
	if (this._keys.length > 0) {
		var geoHelper = this;
		var succeeded2 = function(keyToLL) {
			for (var i = 0; i < geoHelper._keys.length; i++) {
				try {
					var key = geoHelper._keys[i];
					var ll = keyToLL[key];
					if (ll) {
						geoHelper._fProcessLL(key, ll);
					}
				} catch (e) {
					geoHelper._utilities.debugPrint(e);
				}
			}
			succeeded();
		};
		this._utilities.getLLsFromAddresses(this._keys, this._keyToAddress, succeeded2, failed);
	} else {
		succeeded();
	}
}

PB_ScrapingUtilities.prototype.createGeoHelper = function(fProcessLL, utilities) {
	return new PB_ScrapingUtilities_GeoHelper(fProcessLL, utilities);
}
