var PB_TagBar = {
    _closing : false
};

PB_TagBar.open = function() {
    PB_Debug.trace("tag-bar.js","> PB_TagBar.open");
    PB_TagBar._getToolbar().hidden = false;

    var url = document.getElementById("content").contentDocument.location.href;
    var text = PB_Extension.getPiggyBank().getTagString(url);

    var textbox = PB_TagBar._getTextbox();
    textbox.value = text;
    textbox.select();
    textbox.focus();

    PB_TagBar._closing = false;
    PB_Debug.trace("tag-bar.js","< PB_TagBar.open");
}

PB_TagBar.close = function() {
    PB_Debug.trace("tag-bar.js","> PB_TagBar.close");
    PB_TagBar._getToolbar().hidden = true;

    PB_TagBar._resetListbox(false);

    _content.focus();
    PB_Debug.trace("tag-bar.js","< PB_TagBar.close");
}

PB_TagBar.onTag = function() {
    PB_Debug.trace("tag-bar.js","> PB_TagBar.onTag");
    PB_TagBar.close();
    PB_TagBar._tag(false);
    PB_Debug.trace("tag-bar.js","< PB_TagBar.onTag");
}

PB_TagBar.onTagAndPublish = function() {
    PB_Debug.trace("tag-bar.js","> PB_TagBar.onTagAndPublish");
    PB_TagBar.close();
    PB_TagBar._tag(true);
    PB_Debug.trace("tag-bar.js","< PB_TagBar.onTagAndPublish");
}

PB_TagBar.onCancel = function() {
    PB_Debug.trace("tag-bar.js","> PB_TagBar.onCancel");
    PB_TagBar.close();
    PB_Debug.trace("tag-bar.js","< PB_TagBar.onCancel");
}

PB_TagBar.onBlur = function() {
    PB_Debug.trace("tag-bar.js","> PB_TagBar.onBlur");
    var f = function() {
        if (!f._cancel) {
            PB_TagBar.close();
            PB_TagBar._closingFunction = null;
        }
    };
    f._cancel = false;
    
    setTimeout(f, 500);
    
    PB_TagBar._closingFunction = f;
    PB_Debug.trace("tag-bar.js","< PB_TagBar.onBlur");
}

PB_TagBar.onFocus = function() {
    PB_Debug.trace("tag-bar.js","> PB_TagBar.onFocus");
    if (PB_TagBar._closingFunction) {
        PB_TagBar._closingFunction._cancel = true;
        PB_TagBar._closingFunction = null;
    }
    PB_Debug.trace("tag-bar.js","< PB_TagBar.onFocus");
}

PB_TagBar.onKeyUp = function(evt) {
    PB_Debug.trace("tag-bar.js","> PB_TagBar.onKeyUp");
    evt = (evt) ? evt : event;

    var listbox = PB_TagBar._getListbox();

    if (!listbox.disabled) {
        if (evt.keyCode == 13) { // Enter
            PB_TagBar._complete();
        } else if (evt.keyCode == 27) { // ESC
            PB_TagBar._resetListbox(true);
        } else if (evt.keyCode == 38 /* arrow up */ || evt.keyCode == 40 /* arrow down */) {
            var i = listbox.selectedIndex;

            if (evt.keyCode == 38) {
                i = i - 1;
            } else if (evt.keyCode == 40) {
                i = i + 1;
            }

            i = Math.min(Math.max(i, 0), listbox.getRowCount() - 1);
            listbox.selectedIndex = i;
            listbox.scrollToIndex(i);
        } else {
            setTimeout(PB_TagBar._suggestCompletion, 50);
        }

        evt.cancelBubble = true;
    } else {
        if (evt.keyCode == 13) { // Enter
            PB_TagBar.close();
            PB_TagBar._tag(false);
        } else if (evt.keyCode == 27) { // ESC
            PB_TagBar.close();
        } else {
            setTimeout(PB_TagBar._suggestCompletion, 50);
        }
    }
    
    PB_Debug.trace("tag-bar.js","< PB_TagBar.onKeyUp");
}

PB_TagBar._tag = function(publish) {
    PB_Debug.trace("tag-bar.js","> PB_TagBar._tag");
    var textbox = PB_TagBar._getTextbox();
    var text = textbox.value;

    var browser = document.getElementById("content");
    var url = browser.contentDocument.location.href;
    var title = browser.contentDocument.title;

    PB_Extension.getPiggyBank().resetTags(url);
    var s = PB_Extension.getPiggyBank().tagWebPage(url, title, text, publish);
    if (s != "") {
        alert(s);
    }
    PB_Debug.trace("tag-bar.js","< PB_TagBar._tag");
}

PB_TagBar._complete = function() {
    PB_Debug.trace("tag-bar.js","> PB_TagBar._complete");
    var listbox = PB_TagBar._getListbox();
    var textbox = PB_TagBar._getTextbox();
    var text = textbox.value;
    var cursor = PB_TagBar._findCursor(textbox);
    var startOfTag = PB_TagBar._findStartOfTag(text, cursor);
    var prefix = text.substring(startOfTag, cursor);

    if (listbox.selectedIndex >= 0) {
        var completion = listbox.selectedItem.value;
        if (completion.toLowerCase().indexOf(prefix.toLowerCase()) == 0) {
            var newText = text.substring(0, startOfTag) + completion + text.substring(cursor);
            textbox.value = newText;

            cursor = startOfTag + completion.length;
            textbox.selectionStart = cursor;
            textbox.selectionEnd = cursor;

            PB_TagBar._resetListbox(true);
        }
    }
    PB_Debug.trace("tag-bar.js","< PB_TagBar._complete");
}

PB_TagBar._suggestCompletion = function() {
    PB_Debug.trace("tag-bar.js","> PB_TagBar._suggestCompletion");
    var listbox = PB_TagBar._getListbox();
    var textbox = PB_TagBar._getTextbox();
    var text = textbox.value;
    var cursor = PB_TagBar._findCursor(textbox);
    var startOfTag = PB_TagBar._findStartOfTag(text, cursor);
    var prefix = text.substring(startOfTag, cursor);

    listbox = PB_TagBar._resetListbox(true);

    if ((prefix) && prefix.length > 0) {
        var tags = PB_Extension.getPiggyBank().suggestTagCompletion(prefix);

        if (tags.size() > 0) {
            for (var i = 0; i < tags.size(); i++) {
                var tag = tags.get(i);
                listbox.appendItem(tag, tag);
            }
            listbox.disabled = false;
            listbox.selectedIndex = 0;
        }
    }

    PB_Debug.trace("tag-bar.js","< PB_TagBar._suggestCompletion");
}

PB_TagBar._getToolbar = function() {
    PB_Debug.trace("tag-bar.js","PB_TagBar._getToolbar");
    return document.getElementById("piggyBank-tagToolbar");
}

PB_TagBar._getListbox = function() {
    PB_Debug.trace("tag-bar.js","PB_TagBar._getListbox");
    return document.getElementById("piggyBank-tagToolbar-listbox");
}

PB_TagBar._resetListbox = function(disabled) {
    PB_Debug.trace("tag-bar.js","PB_TagBar._resetListbox");
    var listbox = PB_TagBar._getListbox();
    var newlist = listbox.cloneNode(false);
    listbox.parentNode.replaceChild(newlist, listbox);
    newlist.disabled = disabled;
    return newlist;
}

PB_TagBar._getTextbox = function() {
    PB_Debug.trace("tag-bar.js","PB_TagBar._getTextbox");
    return document.getElementById("piggyBank-tagToolbar-textbox");
}

PB_TagBar._findCursor = function(textbox) {
    PB_Debug.trace("tag-bar.js","PB_TagBar._findCursor");
    return Math.min(textbox.selectionStart, textbox.selectionEnd);
}

PB_TagBar._findStartOfTag = function(text, cursor) {
    PB_Debug.trace("tag-bar.js","> PB_TagBar._findStartOfTag");
    var i = text.lastIndexOf(",", cursor);
    if (i < 0) {
        i = 0;
    } else {
        i += 1;
    }
    while (i < cursor && text.charAt(i) == " ") {
        i++;
    }
    PB_Debug.trace("tag-bar.js","< PB_TagBar._findStartOfTag");
    return i;
}
