/*
 * Utilities for dealing with the browser.
 */
 
var PB_BrowserUtilities = {};

PB_BrowserUtilities.getTabBrowser = function() {
    return top.document.getElementById("content");
};
    
PB_BrowserUtilities.createProgressListener = function() {
    return {
        onLocationChange : function(webProgress, request, location) {},
        onProgressChange : function(webProgress, request, curSelfProgress, maxSelfProgress, curTotalProgress, maxTotalProgress) {},
        onSecurityChange : function(webProgress, request, state) {},
        onStateChange : function(webProgress, request, stateFlags, status) {},
        onStatusChange : function(webProgress, request, status, message) {},
        QueryInterface : function(iid) {
            if (!iid.equals(Components.interfaces.nsIWebProgressListener) &&
                !iid.equals(Components.interfaces.nsISupportsWeakReference) &&
                !iid.equals(Components.interfaces.nsISupports)) {
                throw Components.results.NS_ERROR_NO_INTERFACE;
            }
            return this;
        }
    }
};

PB_BrowserUtilities.createObserver = function() {
    return {
        observe : function(subject, topic, data) {},
        QueryInterface : function(iid) {
            if (!iid.equals(Components.interfaces.nsIObserver) &&
                !iid.equals(Components.interfaces.nsISupportsWeakReference) &&
                !iid.equals(Components.interfaces.nsISupports)) {
                throw Components.results.NS_ERROR_NO_INTERFACE;
            }
            return this;
        }
    }
};

PB_BrowserUtilities.isJavaAvailable = function() {
    var java_available = false;

    try {
        var str = new java.lang.String("abc");
        java_available = str.matches("a.c");
        // the above lines check three things:
        //  1) the liveconnect subsystem is present
        //  2) the JVM is at least version 1.4
        //  3) the execution worked fine
    } catch (e) {
        // if any exception is triggered, java didn't work
    }
    
    return java_available;
}

// NOTE: this method requires java, so make sure to call it only after
// checking if the java subsystem works, or lack of java presence will
// result in all port being signaled as being in use
PB_BrowserUtilities.isPortInUse = function(port) {
    var port_in_use = false;
    
    try {
        var socket = new java.net.ServerSocket(port,1,java.net.InetAddress.getByAddress([127,0,0,1]));
        socket.close();
    } catch (e) {
        port_in_use = true;
    }
    
    return port_in_use;
}

PB_BrowserUtilities.loadURI = function(url,referrer) {
    document.getElementById('content').loadURI(url,referrer);
}

PB_BrowserUtilities.openNewTab = function(url) {
    document.getElementById('content').addTab(url);
}

PB_BrowserUtilities.openNewWindow = function(url) {
    openDialog("chrome://browser/content/browser.xul", "_blank", "chrome,all,dialog=no", url, null, null);
}
