// from mcqueenorama at gmail dot com; see also
// http://groups-beta.google.com/group/Google-Maps-API/browse_thread/thread/fdb49a801fd6bf7d/afafb60f21f3d556
zoomIncrement = function(boundsSize, dataSize, exp) {
    var new_exp;
    if ((dataSize.width > boundsSize.width * Math.pow(2, exp)) || (dataSize.height > boundsSize.height * Math.pow(2, exp))) {
        if (exp < 0)
            return exp + 1;
        new_exp = exp + 1;
    } else {
        if (exp > 0)
            return exp;
        new_exp = exp - 1;
    }

    return zoomIncrement(boundsSize, dataSize, new_exp);
} 

function _makeMarker(map, x) {
    // location
    var point = new GPoint(x.getElementsByTagName("point")[0].getAttribute("lng"), x.getElementsByTagName("point")[0].getAttribute("lat"));
    // icon
    var icon = new GIcon();
    var imageurl = x.getElementsByTagName("icon")[0].getAttribute("image");
    // for safari, where & => &#38; and .replace doesn't seem to work
    while (imageurl.indexOf('&#38;') != -1) {
        var pos = imageurl.indexOf('&#38;');
        imageurl = imageurl.substring(0, pos) + "&" + imageurl.substring(pos + "&#38;".length);
    }
    icon.image = imageurl;
    icon.shadow = "http://www.google.com/mapfiles/shadow50.png";
    icon.iconSize = new GSize(40, 34);
    icon.shadowSize = new GSize(67, 34);
    icon.iconAnchor = new GPoint(19, 34);
    icon.infoWindowAnchor = new GPoint(19, 0);
    icon.infoShadowAnchor = new GPoint(38, 25);

    // marker
    var marker = new GMarker(point, icon);
    var info = x.getElementsByTagName("info")[0];
    var xslt = x.getAttribute("infoStyle");

    // info display
    // safari can't handle this, not sure why not - it worked before
    // @@@one possibility is to somehow serve XML and call W3C XSLT service
    GEvent.addListener(marker, "click", function() {
        marker.openInfoWindowXslt(info, xslt);
        map.recenterOrPanToLatLng(point);
    });
    return marker;
}

// displays xml generated by longwell
function _Gdisplay(x) {
    document.getElementById('loading').style.display='none';
    if (GBrowserIsCompatible()) {
	// new map
        var map = new GMap(document.getElementById("map"));

	// center
        var mapinfo = x.documentElement.getElementsByTagName("center");
	var center = new GPoint(mapinfo[0].getAttribute("lng"), mapinfo[0].getAttribute("lat"));
	map.centerAtLatLng(center);

	// zoom
        map.zoomTo(8);
        var originalBounds = map.getBoundsLatLng();
        var originalZoomLevel = map.getZoomLevel();

        var originalLatSpan = Math.abs(originalBounds.maxY - originalBounds.minY);
        var originalLongSpan = Math.abs(originalBounds.maxX - originalBounds.minX);
        var originalBounds = new GSize(originalLongSpan, originalLatSpan);
        var dataBounds = new GSize(x.documentElement.getElementsByTagName("span")[0].getAttribute("lng"), x.documentElement.getElementsByTagName("span")[0].getAttribute("lat"));

        map.zoomTo(originalZoomLevel + zoomIncrement(originalBounds, dataBounds, 0));

	// add controls
        map.addControl(new GLargeMapControl());
        map.addControl(new GMapTypeControl());

	// go through XML for each location
        var markers = x.documentElement.getElementsByTagName("location");
        for (var i = 0; i < markers.length; i++) {
            var marker = _makeMarker(map, markers[i]);
            map.addOverlay(marker);
        }

        // legend - if it doesn't work, don't worry, just assume it isn't there
        try {
            var legend = x.documentElement.getElementsByTagName("legend")[0];
            window.parent.Map_setLegend(legend);
        } catch (e) { }
    }
}

// run after page is loaded
function _initGMap() {
    var urlOffset = document.location.search.indexOf("url=") + "url=".length;
    var url = document.location.search.substring(urlOffset);
    url = unescape(url);
    try {
        var xmlhttp = GXmlHttp.create();
        xmlhttp.open("GET", url);
        xmlhttp.onreadystatechange=function() {
            if (xmlhttp.readyState==4) {
                _Gdisplay(xmlhttp.responseXML);
            }
        }
        xmlhttp.send(null); // Whoops, IE *needs* this to be last, Moz is lenient.
    } catch (e) {
        // um...this try/catch seems to enable Safari functionality...
    }
}
